package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBufferPointerNameARB implements GLEnum {
	BUFFER_MAP_POINTER(0x88bd);
	
	private final int glEnum;

	GLBufferPointerNameARB(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBufferPointerNameARB> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBufferPointerNameARB fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x88bd -> BUFFER_MAP_POINTER;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBufferPointerNameARB");
		};
	}
}